/**
 * Copyright (C) 2011 Ovea <dev@ovea.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.ovea.i18n.guice;

import com.google.inject.AbstractModule;
import com.google.inject.matcher.Matchers;
import com.ovea.i18n.DefaultI18NServiceFactory;
import com.ovea.i18n.I18NServiceFactory;
import com.ovea.i18n.MessageHandler;

public class I18NModule extends AbstractModule {

    private boolean debug;

    @Override
    protected void configure() {
        bind(I18NServiceFactory.class).to(DefaultI18NServiceFactory.class);
        // @Message handling
        binder().bindListener(Matchers.any(), new MessageHandler());
    }

    public I18NServiceFactory nServiceFactory() {
        DefaultI18NServiceFactory factory = new DefaultI18NServiceFactory();
        factory.setDebug(isDebug());
        return factory;
    }

    public void setDebug(boolean debug) {
        this.debug = debug;
    }

    public boolean isDebug() {
        return debug;
    }
}
